#!/usr/bin/ruby -w

# haiku (c) Gasman 2005
# bootstrap.rb: Generate bootable tape image from raw Spectrum binary
# usage: ruby bootstrap.rb infile outfile
# infile = raw machine code file, compiled to run from 23769
# outfile = name of output .tap file

# ZXMedia library available from http://www.west.co.tt/matt/speccy/zxmedia/
require "zxmedia"

data = [0x00,0x01,0x00,0x00,0xec,0xc0,0x30,0x0e,0x00,0x00,0xd9,0x5c,0x00,0x3a]
# data above is to be loaded at 23755
# 00 01 = line number = 1
# 00 00 = line length (unset)
# EC C0 30 = GO TO USR 0 ('0' = fake ASCII representation of real start address)
# 0E = marker to indicate floating-point number follows
# 00 00 D9 5C 00 = floating-point representation of starting address 23769
# 3A = :
# Following byte is address 23769, from where machine code follows immediately.

bin = IO.read(ARGV[0]).unpack("C*")
data += bin
bas = ZXMedia::BASICBlock.new('Haiku', data, data.length, 1)
puts bas
File.open(ARGV[1], "w") { |io|
	bas.write_tap_block(io)
}
